import sys, httplib
from xml.dom.ext.reader import PyExpat
from xml.dom import ext

SERVER_ADDR = '127.0.0.1'
SERVER_PORT = 8888
ECHO_NS = 'http://uche.ogbuji.net/ws/eg/echo-soapser'

BODY_TEMPLATE = """<SOAP-ENV:Envelope
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:s="http://uche.ogbuji.net/eg/ws/echo-soapser"
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
>
  <SOAP-ENV:Body>
    <s:echo>
      <msg><![CDATA[%s]]></msg>
    </s:echo>
  </SOAP-ENV:Body>
</SOAP-ENV:Envelope>"""


def Echo():
    msg = raw_input("Message to send: ")
    body = BODY_TEMPLATE%(msg)
    blen = len(body)
    requestor = httplib.HTTP(SERVER_ADDR, SERVER_PORT)
    requestor.putrequest('POST', '/eg/ws/echo-soapser')
    requestor.putheader('Host', SERVER_ADDR)
    requestor.putheader('Content-Type', 'text/plain; charset="utf-8"')
    requestor.putheader('Content-Length', str(blen))
    requestor.putheader('SOAPAction', "http://uche.ogbuji.net/eg/ws/echo-soapser")
    requestor.endheaders()
    requestor.send(body)
    (status_code, message, reply_headers) = requestor.getreply()
    reply_body = requestor.getfile().read()

    reader = PyExpat.Reader()
    doc = reader.fromString(reply_body)
    ext.StripXml(doc)
        
    echo_resp = doc.getElementsByTagNameNS(ECHO_NS, 'echoResponse')[0]
    msg_elem = echo_resp.firstChild
    msg = msg_elem.firstChild.data

    print "status code:", status_code
    print "status message:", message
    print "HTTP reply body:\n", reply_body
    print "SOAP response value:", msg


if __name__ == "__main__":
    Echo()

