package com.organizedCampgrounds.proxy;

import java.io.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.*;
import org.apache.soap.util.xml.*;
import java.util.zip.*;

/**
   Serializer for Campsite class which compresses the description string.
 */
public class CampsiteCompSerializer implements Serializer, Deserializer
{

  public void marshall(String inScopeEncStyle, Class javaType,
    Object src, Object context, Writer sink,
    NSStack nsStack, XMLJavaMappingRegistry xjmr,
    SOAPContext ctx)
        throws IllegalArgumentException, IOException
  {
    nsStack.pushScope();

    SoapEncUtils.generateStructureHeader(inScopeEncStyle, javaType, context,
      sink, nsStack, xjmr);

    sink.write(StringUtils.lineSeparator);

    com.organizedCampgrounds.proxy.Campsite src2 =
      (com.organizedCampgrounds.proxy.Campsite)src;
    Parameter param;

    param = new Parameter("description", java.lang.String.class,
      src2.description_Elem, null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("size", int.class, new Integer(src2.size_Elem), null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("shade", int.class, new Integer(src2.shade_Elem),
      null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);


    sink.write("</" + context + '>');

    nsStack.popScope();
  }

  public Bean unmarshall(String inScopeEncStyle, QName elementType,
  Node src, XMLJavaMappingRegistry xjmr,
  SOAPContext ctx)
  throws IllegalArgumentException
  {
    Element root = (Element)src;
    Element tempEl = DOMUtils.getFirstChildElement(root);
    com.organizedCampgrounds.proxy.Campsite target;

    try
    {
      target =
        (com.organizedCampgrounds.proxy.Campsite)com.organizedCampgrounds.proxy.Campsite.class.newInstance
        ();
    }
    catch (Exception e)
    {
      throw new IllegalArgumentException("Problem instantiating bean: "
        + e.getMessage());
    }

    while (tempEl != null)
    {
      Bean paramBean = xjmr.unmarshall(inScopeEncStyle,
      RPCConstants.Q_ELEM_PARAMETER,
      tempEl,
      ctx);
      Parameter param = (Parameter)paramBean.value;
      String tagName = tempEl.getTagName();


      if (tagName.equals("description"))
      {
        target.description_Elem = (java.lang.String)param.getValue();
      }

      if (tagName.equals("size"))
      {
        target.size_Elem = ((Integer)param.getValue()).intValue();
      }

      if (tagName.equals("shade"))
      {
        target.shade_Elem = ((Integer)param.getValue()).intValue();
      }


      tempEl = DOMUtils.getNextSiblingElement(tempEl);
    }

    return new Bean(com.organizedCampgrounds.proxy.Campsite.class, target);
  }

    public byte[] compressIt(String in){
        byte[] uncompressedBytes = in.toBytes();
            System.out.println("Original length: " + uncompressedMapBytes.length);
            Deflater def = new Deflater();
            def.setInput(uncompressedBytes);
            def.finish();
            byte outbuf[] = new byte[uncompressedBytes.length];
            int len = def.deflate(outbuf);
            System.out.println("Compressed length: " + len);
            compressedBytes = new byte[len];
            for(int i=0; i<len; i++)
                compressedBytes[i] = outbuf[i];
            return compressedBytes;
    }
    
    public String decompressIt(byte[] compressedBytes){
            Inflater inf = new Inflater();
            inf.setInput(compressedBytes);
            byte infbuf[] = new byte[?];
            try{
                System.out.println("Inflated length: " + inf.inflate(infbuf));
            }
            catch(DataFormatException e){
                System.err.println("Err: " + e.getMessage());
            }
            //System.out.println("Result: " + new String(infbuf, 0, infbuf.length>500?500:infbuf.length));
            return new String(infbuf);            
        }
    }
}
