
package com.organizedCampgrounds;

import java.io.*;
import java.net.*;

    public class Client { 
      public static void main( String[] args ) throws Exception { 
        /*
         * Define the location where the campground may be found and
         * the identifier for the campground object.
         */
        com.organizedCampgrounds.proxy.CampgroundProxy campground = 
          new com.organizedCampgrounds.proxy.CampgroundProxy();
        
        ServiceDescriptor descr[] = UDDI.getServiceEndPoints("Campground", "CampgroundPort"); 

        System.out.println("Campgrounds: ");
        for(int i=0; i<descr.length; i++)
          System.out.println("(" + i + ") " + descr[i].description);
        System.out.println("Enter campground number: ");
        BufferedReader keyboardInput =
           new BufferedReader(new InputStreamReader(System.in));
        int campgroundIndex = Integer.parseInt(keyboardInput.readLine());

        System.out.println("URL from UDDI: " + descr[campgroundIndex].url);
        campground.setEndPoint(new URL(descr[campgroundIndex].url));
        
        System.out.println("Price: " + 
          campground.computePrice(Integer.parseInt(args[0])));
        int nCampsites=campground.getNumberOfCampsites();
        for(int i=0; i<nCampsites; i++){
          Campsite campsite = campground.getCampsite(i);
          System.out.println( "Campsite " + i + ": " + campsite.getDescription() + "\n Size: " +
                  campsite.getSize() + " square feet, Shade(1-10):  " + campsite.getShade()); 
        }
        System.out.println("Choose campsite: " );
        String site = keyboardInput.readLine();
        if (site.length() > 0){
          boolean success = campground.reserveCampsite(Integer.parseInt(args[0]), 
             Integer.parseInt(site), "Derek");
          System.out.println("Success: " + success);
        }
      } 
    } 


