package com.palomarCampground;

import com.organizedCampgrounds.*;

public class PalomarCampground implements Campground{
    private Campsite[] campsites = {
         new Campsite("Mountain top campsite with a view of the entire valley.",   500,  8),
         new Campsite("This campsite is very popular since it is so secluded.", 450, 10),
         new Campsite("This is a nice, big site that gets plenty of sunshine and has a lot of room for setting up several tents.", 950, 3)
    };
    private String schedule[][];

    public PalomarCampground(){
        /*
         * Intialize the schedule. A null for a campsite on a day of
         * week means it is available. When it is reserved, it will
         * contain the name of the person holding the reservation.
         */
        schedule = new String[7][]; // For each day of the week
        for(int i=0; i<schedule.length; i++)
            schedule[i] = new String[campsites.length]; // For each site
        for(int dow=0; dow<7; dow++)
            for(int site=0; site<campsites.length; site++)
                schedule[dow][site] = null;
        
    }

    public int computePrice(int day) throws IllegalArgumentException{
        switch(day){
          case 0:
          case 6:
            return 25;
          case 1:
          case 2:
          case 3:
          case 4:
          case 5:
            return 5;
          default:
            throw new IllegalArgumentException("Invalid day of week: " + day);
        }
    }

    public int getNumberOfCampsites(){
        return campsites.length;
    }

    public Campsite getCampsite(int campsiteNumber){
        return campsites[campsiteNumber];
    }

    public boolean reserveCampsite(int dayOfWeek, int campsiteNumber, String name){
        if (schedule[dayOfWeek][campsiteNumber] == null){
            schedule[dayOfWeek][campsiteNumber] = name;
            return true;
        }
        else{
            return false;
        }
    }
}
