import java.net.*; 
import java.util.*; 
import org.apache.soap.*; 
import org.apache.soap.rpc.*;
import org.apache.soap.transport.*;

public class SMTPClient 
{ 
	public static void main( String[] args ) throws Exception 
    { 
		URL url;
		Call call;
		Vector params;
		
		url = new URL ("mailto:smtpsoap@trcs.com");
		String urn = "urn:apachedemo:count"; 

		call = new Call();
		call.setTargetObjectURI (urn); 
		call.setMethodName ("countString"); 
		call.setEncodingStyleURI (Constants.NS_URI_SOAP_ENC); 
		
		String smtpServer = "mail.trcs.com";
		String popServer = "mail.trcs.com";
		String popLogin = "trcs/smtpresponse";
		String popPassword = "frodo1";
		String fromAddress = popLogin + "@" + popServer;
		
		SOAPTransport smtpTransport = 
				new org.apache.soap.transport.smtp.SOAPSMTPConnection (fromAddress,
																		"SOAP SMTP TEST",
																		smtpServer,
																		30000,
																		popServer,
																		popLogin,
																		popPassword);
		
																							  
		call.setSOAPTransport (smtpTransport);
		
		params = new Vector(); 
		params.addElement (new Parameter ("inputString", String.class, "StringToCount", null)); 
		
		call.setParams (params); 

		try 
		{ 
			System.out.println ("invoke service\n" + "  URL= " + url + 
								"\n  URN =" + urn); 
			Response response = call.invoke (url, ""); // invoke the service 

			if (!response.generatedFault()) 
			{ 
				Parameter result = response.getReturnValue (); // response was OK 
				System.out.println ("Result= " + result.getValue ()); 
				System.out.println (result);
			} 
			else 
			{ 
				Fault f = response.getFault (); // an error occurred 
				System.err.println ("Fault= " + f.getFaultCode () + ", " + 
									f.getFaultString ()); 
			} 
		} 
		catch (SOAPException e) // call could not be sent properly 
		{ 
			System.err.println ("SOAPException= " + e.getFaultCode () + ", " +  
								e.getMessage ()); 
		} 
	} 
} 
