#!/usr/bin/env python

# Uses the Web service by Simon Fell
# (referenced at http://xmethods.com/detail.html?id=24) 
# for performing a WHOIS query on a given domain name

import sys

#Import the SOAPy machinery
import soap

#Follow the web service description and use it to create a proxy object
#That represents a remote object transparently
server = soap.get_proxy('http://www.xmethods.net/sd/BabelFishService.wsdl')

if len(sys.argv) > 2:
    tm = sys.argv[1]
    s = sys.argv[2]
else:
    tm = "en_es"
    s = "The rain in spain stays mainly in the plain"

result = server.BabelFish(translationmode=tm, sourcedata=s)
print '"%s" translated with mode %s:\n\n%s'%(s, tm, result)

