import string
from xml import xpath
from xml.dom import implementation, ext
from FtServer.Protocols.Http import SoapHandler

SOFTVER_SOAP_NS = 'http://uche.ogbuji.net/eg/ws/softver-soapser'

VERSION_MAPPINGS = {
    "4suite": "0.11.1",
    "4suiteserver": "0.11.1",
    "pyxml": "0.6.5",
    }

def GetSoftwareVersion(repo, reqbody, respbody):
    context = xpath.Context.Context(reqbody)
    packageName = xpath.Evaluate('string(packageName)', context=context)
    ver = VERSION_MAPPINGS[string.lower(packageName)]

    result = respbody.ownerDocument.createElementNS(
        SOFTVER_SOAP_NS, 's:getCurrentVersionResponse'
        )
    ver_param = respbody.ownerDocument.createElementNS(
        None, 'versionString'
        )
    ver_text = respbody.ownerDocument.createTextNode(ver)
    ver_param.appendChild(ver_text)
    result.appendChild(ver_param)
    respbody.appendChild(result)
    return 1


class SoftVerSoapHandler(SoapHandler.SoapHandler):
    NS_TO_HANDLER_MAPPING = {
        SOFTVER_SOAP_NS: {'getCurrentVersion': GetSoftwareVersion,
                           },
       }


def Register(props):
    handler = SoftVerSoapHandler()
    return [(handler.handle, 'POST')]

