#!/usr/bin/python

from distutils import version
from distutils.core import setup

from FtServer.Core import Constants
from FtServer.Extensions import BootstrapUtil
from FtServer.Extensions.BootstrapUtil import FtssContainer, FtssDocDef
from FtServer.Extensions.BootstrapUtil import FtssXmlDocument

#Set up the 4Suite Server installation utilities
BootstrapUtil.InstallSubCommands()

package_data = []

package_data.append(
    BootstrapUtil.FtssData(
    containers=[
        FtssContainer("/eg",
                      Constants.WORLD_GROUP_ACL_IDENT,
                      Constants.SUPER_USER_GROUP_ACL_IDENT),
        FtssContainer('/eg/ws'),
    ])
)

package_data.append(
    BootstrapUtil.FtssData(
    docdefs=[
        FtssDocDef('WSDL',
                   'wsdl.docdef',
                   ),
    ])
)

package_data.append(
    BootstrapUtil.FtssData(
    xml_documents=[
        FtssXmlDocument('/eg/ws/softver-soapser.wsdl', 'softver-soapser.wsdl',
                        docDef='WSDL'),
        FtssXmlDocument('/eg/ws/softver-soapser.xsd', 'softver-soapser.xsd'),
    ])
)


dist = setup(
    name="SoftwareVersionSampleWebService",
    version="0.5.0",
    description="Web service example: getSoftwareVersion",
    author="Uche Ogbuji",
    author_email="uche.ogbuji@fourthought.com",
    url="http://4Suite.org",
    long_description="Web service example: getSoftwareVersion",
    distclass=BootstrapUtil.Dist,
    # Command function overrides
    cmdclass=BootstrapUtil.Commands,
    ftss_data=package_data,
    verbose=1,
    package_dir={'FtServer.Share' : '.',},
    packages=['FtServer.Share',],
    )

