VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SystemInfoService"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' SystemInfoService.cls
'
' This class implements methods that give system information and control.
'

Option Explicit

Private Const MAX_NAME_LEN As Long = 15
Private Const MAX_OS_LEN As Long = 128

' SYSTEM_INFO - GetSystemInfo()
Private Type SYSTEM_INFO
        dwOemID As Long
        dwPageSize As Long
        lpMinimumApplicationAddress As Long
        lpMaximumApplicationAddress As Long
        dwActiveProcessorMask As Long
        dwNumberOfProcessors As Long
        dwProcessorType As Long
        dwAllocationGranularity As Long
        dwReserved As Long
End Type

' OSVERSIONINFO - GetVersionEx()
Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Private Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Private Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long

' Data members
Private m_si As SYSTEM_INFO

Private m_osvi As OSVERSIONINFO

Private Sub Class_Initialize()
    
On Error GoTo InitErr

    Dim lRet As Long
    
    GetSystemInfo m_si
    
    m_osvi.dwOSVersionInfoSize = 20 + MAX_OS_LEN
    m_osvi.szCSDVersion = Space$(MAX_OS_LEN)
    
    GetVersionEx m_osvi
    
    Exit Sub
    
InitErr:
    
    Exit Sub
    
End Sub

Public Function GetSystemName() As String

    Dim sName As String
    Dim lSize As Long
    Dim lRet As Long
    
    sName = Space$(MAX_NAME_LEN + 1)
    lSize = Len(sName)
    lRet = GetComputerName(sName, 50)
    
    GetSystemName = sName
    Exit Function
    
End Function

Public Function GetNumberOfProcessors() As Integer
    
    GetNumberOfProcessors = m_si.dwNumberOfProcessors
    Exit Function
    
End Function

Public Function GetOS() As String

    Select Case m_osvi.dwPlatformId
        Case 1
            If m_osvi.dwMinorVersion = 0 Then
                GetOS = "Windows 95"
            ElseIf m_osvi.dwMinorVersion = 10 Then
                GetOS = "Windows 98"
        End If
        
        Case 2
            If m_osvi.dwMajorVersion = 3 Then
                GetOS = "Windows NT 3.51"
            ElseIf m_osvi.dwMajorVersion = 4 Then
                GetOS = "Windows NT 4.0"
            ElseIf m_osvi.dwMajorVersion = 5 Then
                GetOS = "Windows 2000"
        End If
        
        Case Else
            GetOS = "Unknown"
    End Select
    Exit Function
   
End Function

