VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LowBoy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' LowBoy
'
' Message Handler Object Using Low Level SOAP API

Public Sub ProcessRequest(request As ASPTypeLibrary.request, response As ASPTypeLibrary.response)
    
On Error GoTo ProcessErr

    ' Always text/xml
    response.ContentType = "text/xml"
    
    ' Read and write SOAP messages
    Dim soapIn As New SoapReader
    Dim soapOut As New SoapSerializer
    
    ' From our first app, this does the work
    Dim si As New SystemInfoService
    
    Dim strBodyName As String
    Dim strResult As String
    
    ' Load the request, write out to the response
    soapIn.Load request
    soapOut.Init response
    
    strBodyName = soapIn.RPCStruct.baseName
    
    ' Find the appropriate method to call
    Select Case strBodyName
    
        Case "GetOS"
            strResult = si.GetOS()
        
        Case "GetSystemName"
            strResult = si.GetSystemName()
        
        Case "GetNumberOfProcessors"
            strResult = si.GetNumberOfProcessors()
        
        Case Else
            Err.Raise 1000, "LowBoy", "Method not found"
        End Select
           
    ' Write out the response
    soapOut.startEnvelope
    soapOut.startBody
    soapOut.startElement strBodyName & "Response", "http://tempuri.org/message/"
    soapOut.startElement "Result", "http://tempuri.org/message/"
    soapOut.writeString strResult
    soapOut.endElement
    soapOut.endElement
    soapOut.endBody
    soapOut.endEnvelope
        
    Exit Sub
    
ProcessErr:
    ' Create a Fault
    response.Status = 500
    
    soapOut.startEnvelope
    soapOut.startBody
    soapOut.startFault "Server", Err.Description
    soapOut.endFault
    soapOut.endBody
    soapOut.endEnvelope
      
    Exit Sub

End Sub

